/* 
 * Copyright (C) 2001-2012 Michael Fuchs
 *
 * This file is part of herold.
 * 
 * herold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * herold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with herold.  If not, see <http://www.gnu.org/licenses/>.  
 */
package org.dbdoclet;

import java.io.IOException;

public class CreatePathException extends IOException {

    /**
     * 
     */
    private static final long serialVersionUID = 1L;
    public static final int UNKNOWN = 0;
    public static final int FILE_PARENT = 1;
    public static final int PERMISSION_DENIED = 2;
    public static final int PATH_TOO_LONG = 3;

    private String path;
    private int reason;

    public CreatePathException(String path) {

        super(path);

        this.path = path;
    }

    public CreatePathException(String path, int reason) {

        super(path);

        this.path = path;
        this.reason = reason;
    }

    public String getPath() {
        return path;
    }

    public int getReason() {
        return reason;
    }

    public boolean hasFileParent() {

        if (reason == FILE_PARENT) {
            return true;
        }

        return false;
    }

    public boolean isPermissionDenied() {

        if (reason == PERMISSION_DENIED) {
            return true;
        }

        return false;
    }

    public boolean isPathTooLong() {

        if (reason == PATH_TOO_LONG) {
            return true;
        }

        return false;
    }
}
