/* 
 * Copyright (C) 2001-2012 Michael Fuchs
 *
 * This file is part of herold.
 * 
 * herold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * herold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with herold.  If not, see <http://www.gnu.org/licenses/>.  
 */
package org.dbdoclet.trafo.html.docbook.editor;

import org.dbdoclet.trafo.tag.docbook.DocBookElement;
import org.dbdoclet.trafo.tag.docbook.DocBookTagFactory;
import org.dbdoclet.trafo.tag.docbook.ListItem;

public class LiEditor extends Editor {

    @Override
    public EditorInstruction edit(EditorInstruction values) throws EditorException {

        setValues(super.edit(values));
        DocBookTagFactory dbfactory = values.getTagFactory();

        DocBookElement parent = getParent();
        
        if (parent instanceof ListItem) {
            
            setParent((DocBookElement) getParent().getParentNode());
            parent = getParent();
        }

        DocBookElement item = dbfactory.createListItem();
        copyCommonAttributes(getHtmlElement(), item);
        
        item.setParentNode(parent);
        parent.appendChild(item);

        setCurrent(dbfactory.createPara());
        getCurrent().setParentNode(item);
        item.appendChild(getCurrent());

        traverse(true);

        return finalizeValues();
    }
}
