/* 
 * Copyright (C) 2001-2012 Michael Fuchs
 *
 * This file is part of herold.
 * 
 * herold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * herold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with herold.  If not, see <http://www.gnu.org/licenses/>.  
 */
package org.dbdoclet.trafo.tag.docbook;

import java.util.HashMap;


public class Warning extends DocBookElement {

    private static String tag = "warning";

    Warning() {
        super(tag);

        setFormatType(FORMAT_BLOCK);
    }

    Warning(String strTitle) {
        super(tag);

        Title title = new Title(strTitle);
        title.setParentNode(this);
        appendChild(title);

        setFormatType(FORMAT_BLOCK);
    }

    Warning(String strTitle, String text) {
        super(tag);

        Title title = new Title(strTitle);
        title.setParentNode(this);
        appendChild(title);

        appendChild(new Para(text));

        setFormatType(FORMAT_BLOCK);
    }

    public static String getTag() {

        return tag;
    }

    public static HashMap<String, Object> getAttributeMap() {

        return new HashMap<String, Object>();
    }
}
